import re
from typing import NamedTuple
from enum import Enum, auto

# Ключевые слова, описывающие граф
scope = [
    "__BEGIN__",
    "__END__"
]

class Parms():
    __slots__=(
        'module',
        'entry_func',
        'predicate',
        'selector',
        'function',
        'morphism',
        'parallelism'
    )
    def __init__(self):
        for slot in self.__slots__:
            setattr(self, slot, None)
    
    def __str__(self):
        stri = ""
        for s in self.__slots__:
            stri += s+": {}, ".format(getattr(self, s))
        return stri

#Props is line "[prop=smth, ...]"
def parm_from_props(props):
    parm = Parms()
    rs =re.split(r",\s*", props[:-1]) #.split(r", ")
    for r in rs:
        r=r.split(r"=", 1)
        for s in parm.__slots__:
            if s == r[0]:
                setattr(parm, s, r[1])
    return parm

def parm_from_entln(raw):
    res = re.split(r"\[", raw, 1)
    return res[0], parm_from_props(res[1])

def parm_from_topln(raw):
    print(raw)
    spl = re.split(r"\s*(=>|->|\[)\s*", raw)
    print(spl)

    
# ent = [{"name":{"module":"val" , "entr_func":"val"...}}]

file = open("./testgr.adot", "r")
dot = file.read()
graphcheck = re.fullmatch(r"\A(digraph)\s+\w*\n{(.*\s)*}\Z", dot)
if graphcheck is None:
    print("Incorrect graph, check syntax!")
    exit()
    
file.seek(0)
dotfile = file.readlines()

entities = {}
topology = {}

# ent_re - regular expr for edges, states, functions properties
ent_re = re.compile(r"^\w+\[.*\]$")
# top_re - regular expr for topology properties, most time consuming one
top_re = re.compile(r"^(\w+,?)+(->|=>)(\w+,?)+(\[(\w+=(\(?\w+,?\)?)+,?)+\])?")
# (r"^\w[\w\s,]*(->|=>)\s*\w[\w\s,=\[\]()]*$")
# com_re - regular expr for comment
com_re = re.compile(r"^\s*//.*$")

for i, ln in enumerate(dotfile):
    ln = re.sub(r"\s", "", ln) #deleting all spaces
    if com_re.match(ln) or len(ln)==0:
        continue
    elif ent_re.match(ln):
        name, parm = parm_from_entln(ln)
        entities[name] = parm
    elif top_re.match(ln):
        parm_from_topln(ln)


#for e in entities:
#    print(e, entities[e])
exit()



# Все что до __BEGIN__ считается объявлением
beg = re.search((scope[0]), dotfile).start()

entities = {}

#Парсинг свойств переходов и состояний
rawents = re.findall(r"\w+\s*?\[.*\]", dotfile[:beg])
for raw in rawents:
    res = re.split(r"\s+", raw, 1)
    ent = Parms()
    rs =re.split(r",\s*", res[1][1:-1]) #.split(r", ")
    for r in rs:
        r=r.split(r"=", 1)
        for s in ent.__slots__:
            if s == r[0]:
                setattr(ent, s, r[1])
    entities[res[0]] = ent

for s in entities:
    print(s, entities[s])

#Парсинг топологии графа
rawstmts = re.findall(r"\s*([\w,\s]*(->|=>)[\w,\s]*(\[.*\])?)\n", dotfile[beg:])
print(rawstmts)
# for raw in rawstmts:
    

